module UU
  module OS
    module ActivityStateTemplate
      class ActivityStateParticipant

        # Allows setting by the role competent for the activity.
        COMPETENT_ROLE = 'COMPETENT_ROLE'

        # Allows setting by the executive role of the activity.
        EXECUTIVE_ROLE = 'EXECUTIVE_ROLE'

        # Allows setting by the owner of the activity (who is both the competent and the executive role).
        OWNER = 'OWNER'

        # Allows setting by other authorized roles that are neither competent nor executive.
        OTHERS = 'OTHERS'

        # Allows setting only by system.
        SYSTEM = 'SYSTEM'

      end
    end
  end
end