require 'uu/os/rest/dto'

module UU
  module OS
    
      module Attachment

        class AttachmentSetAttributes < UU::OS::REST::DTO

          # The new code of the attachment. When nil is set, the code is not modified. The code must be unique
          # in a given artifact, otherwise the setAttributes command fails.
          attr_accessor :code

          # The new name of the attachment. When nil is set, the name is taken from the attachment file name.
          # The name must be unique in a given artifact, otherwise the setAttributes command fails.
          attr_accessor :name

          # The new description of the attachment. When nil is set, the description is not modified.
          attr_accessor :description

          def code 
            attributes[:code]
          end

          def code=(val) 
            attributes[:code] = val
          end

          def name 
            attributes[:name]
          end

          def name=(val) 
            attributes[:name] = val
          end

          def description 
            attributes[:description]
          end

          def description=(val) 
            attributes[:description] = val
          end

        end

      end
    end

end
