require 'uu/os/rest/dto'
require 'uu/os/uesuri'

# Module Unicorn Universe.
module UU
  # Module Operating System.
  module OS
    # Module Permission.
    module Permission
      # @see Permission#get_authority_data
      class PermissionGetAuthorityData < UU::OS::REST::DTO

        # @see Permission#get_authority_data
        attr_accessor :authority_uri

        # @see Permission#get_authority_data
        attr_accessor :requested_mime_type
        def authority_uri
          attributes[:authorityUri]
        end

        def authority_uri=(val)
          if val
            attributes[:authorityUri] = UU::OS::UESURI.new(val)
          else
            attributes[:authorityUri] = nil
          end
        end

        def requested_mime_type
          attributes[:requestedMimeType]
        end

        def requested_mime_type=(val)
          attributes[:requestedMimeType] = val
        end

      end
    end

  end
end

