require 'uu/os/rest/dto'
require 'uu/os/env/version_strategy'


module UU
  module OS
    module SheetTemplate
      # @see SheetTemplate#check_in
      class SheetTemplateCheckIn < UU::OS::REST::DTO

        # @see SheetTemplate#check_in
        attr_accessor :name

        # @see SheetTemplate#check_in
        attr_accessor :code

        # @see SheetTemplate#check_in
        attr_accessor :description

        # @see SheetTemplate#check_in
        attr_accessor :content

        # @see SheetTemplate#check_in
        attr_accessor :version_label

        # @see SheetTemplate#check_in
        attr_accessor :version_strategy
        
        def name 
          attributes[:name]
        end

        def name=(val) 
          attributes[:name] = val
        end

        def code 
          attributes[:code]
        end

        def code=(val) 
          attributes[:code] = val
        end

        def description 
          attributes[:description]
        end

        def description=(val) 
          attributes[:description] = val
        end

        def content 
          attributes[:content]
        end

        def content=(val) 
          attributes[:content] = val
        end

        def version_label 
          attributes[:versionLabel]
        end

        def version_label=(val) 
          attributes[:versionLabel] = val
        end

        def version_strategy 
          attributes[:versionStrategy]
        end

        def version_strategy=(val) 
          attributes[:versionStrategy] = val
        end

        def to_hash 
          hash = super()
          if hash[:versionStrategy].nil?
            hash[:versionStrategy] = UU::OS::Env::VersionStrategy::OVERWRITE_VERSION
          end
          hash
        end

      end
    end

  end
end
