require 'uu/os/rest/dto'
require 'uu/os/uesuri'

# Module Unicorn Universe.
module UU
  # Module Application Deployment Kit.
  module OS
    # Module Visual Use Case.
    module VisualUseCase
      # @see VisualUseCase#create
      class VisualUseCaseCreate < UU::OS::REST::DTO

        # @see VisualUseCase#create
        attr_accessor :name

        # @see VisualUseCase#create
        attr_accessor :code

        # @see VisualUseCase#create
        attr_accessor :description

        # @see VisualUseCase#create
        attr_accessor :security_level

        # @see VisualUseCase#create
        attr_accessor :icon_uri

        # @see VisualUseCase#create
        attr_accessor :controller_url_path

        # @see VisualUseCase#create
        attr_accessor :controller_class

        # @see VisualUseCase#create
        attr_accessor :controller_engine

        # @see VisualUseCase#create
        attr_accessor :competent_role_uri

        # @see VisualUseCase#create
        attr_accessor :meta_artifact_uri

        # @see VisualUseCase#create
        attr_accessor :options

        # @see VisualUseCase#create
        attr_accessor :component_content
        
        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def description
          attributes[:description]
        end

        def description=(val)
          attributes[:description] = val
        end

        def security_level
          attributes[:securityLevel]
        end

        def security_level=(val)
          attributes[:securityLevel] = val
        end

        def icon_uri
          attributes[:iconUri]
        end

        def icon_uri=(val)
          if val
            attributes[:iconUri] = UU::OS::UESURI.new(val)
          else
            attributes[:iconUri] = nil
          end
        end

        def controller_url_path
          attributes[:controllerUrlPath]
        end

        def controller_url_path=(val)
          attributes[:controllerUrlPath] = val
        end

        def controller_class
          attributes[:controllerClass]
        end

        def controller_class=(val)
          attributes[:controllerClass] = val
        end

        def controller_engine
          attributes[:controllerEngine]
        end

        def controller_engine=(val)
          attributes[:controllerEngine] = val
        end

        def competent_role_uri
          attributes[:competentRoleUri]
        end

        def competent_role_uri=(val)
          if val
            attributes[:competentRoleUri] = UU::OS::UESURI.new(val)
          else
            attributes[:competentRoleUri] = nil
          end
        end

        def meta_artifact_uri
          attributes[:metaArtifactUri]
        end

        def meta_artifact_uri=(val)
          if val
            attributes[:metaArtifactUri] = UU::OS::UESURI.new(val)
          else
            attributes[:metaArtifactUri] = nil
          end
        end

        def options
          attributes[:options]
        end

        def options=(val)
          if val
            attributes[:options] = UU::OS::REST::BinaryValue.new(val)
          else
            attributes[:options] = nil
          end
        end

        def component_content
          attributes[:componentContent]
        end

        def component_content=(val)
          attributes[:componentContent] = val
        end

      end
    end
  end

end
